clang 10.0.0git

Public Member Functions | Static Public Member Functions | Friends | List of all members
clang::OMPScheduleClause Class Reference

This represents 'schedule' clause in the '#pragma omp ...' directive. More...

`#include "clang/AST/OpenMPClause.h"`

Inheritance diagram for clang::OMPScheduleClause:
[legend]
Collaboration diagram for clang::OMPScheduleClause:
[legend]

## Public Member Functions
| OMPScheduleClause (SourceLocation StartLoc, SourceLocation LParenLoc, SourceLocation KLoc, SourceLocation CommaLoc, SourceLocation EndLoc, OpenMPScheduleClauseKind Kind, Expr *ChunkSize, Stmt *HelperChunkSize, OpenMPScheduleClauseModifier M1, SourceLocation M1Loc, OpenMPScheduleClauseModifier M2, SourceLocation M2Loc)
| Build 'schedule' clause with schedule kind Kind and chunk size expression ChunkSize. More...
| OMPScheduleClause ()
| Build an empty clause. More...
OpenMPScheduleClauseKind | getScheduleKind () const
| Get kind of the clause. More...
OpenMPScheduleClauseModifier | getFirstScheduleModifier () const
| Get the first modifier of the clause. More...
OpenMPScheduleClauseModifier | getSecondScheduleModifier () const
| Get the second modifier of the clause. More...
SourceLocation | getLParenLoc ()
| Get location of '('. More...
SourceLocation | getScheduleKindLoc ()
| Get kind location. More...
SourceLocation | getFirstScheduleModifierLoc () const
| Get the first modifier location. More...
SourceLocation | getSecondScheduleModifierLoc () const
| Get the second modifier location. More...
SourceLocation | getCommaLoc ()
| Get location of ','. More...
Expr * | getChunkSize ()
| Get chunk size. More...
const Expr * | getChunkSize () const
| Get chunk size. More...
child_range | children ()
const_child_range | children () const
child_range | used_children ()
const_child_range | used_children () const
Public Member Functions inherited from clang::OMPClause
SourceLocation | getBeginLoc () const
| Returns the starting location of the clause. More...
SourceLocation | getEndLoc () const
| Returns the ending location of the clause. More...
void | setLocStart (SourceLocation Loc)
| Sets the starting location of the clause. More...
void | setLocEnd (SourceLocation Loc)
| Sets the ending location of the clause. More...
OpenMPClauseKind | getClauseKind () const
| Returns kind of OpenMP clause (private, shared, reduction, etc.). More...
bool | isImplicit () const
child_range | children ()
const_child_range | children () const
child_range | used_children ()
| Get the iterator range for the expressions used in the clauses. More...
const_child_range | used_children () const
Public Member Functions inherited from clang::OMPClauseWithPreInit
const Stmt * | getPreInitStmt () const
| Get pre-initialization statement for the clause. More...
Stmt * | getPreInitStmt ()
| Get pre-initialization statement for the clause. More...
OpenMPDirectiveKind | getCaptureRegion () const
| Get capture region for the stmt in the clause. More...

## Static Public Member Functions
static bool | classof (const OMPClause *T)
Static Public Member Functions inherited from clang::OMPClause
static bool | classof (const OMPClause *)
Static Public Member Functions inherited from clang::OMPClauseWithPreInit
static OMPClauseWithPreInit * | get (OMPClause *C)
static const OMPClauseWithPreInit * | get (const OMPClause *C)

## Friends
class | OMPClauseReader

## Additional Inherited Members
Public Types inherited from clang::OMPClause
using | child_iterator = StmtIterator
using | const_child_iterator = ConstStmtIterator
using | child_range = llvm::iterator_range< child_iterator >
using | const_child_range = llvm::iterator_range< const_child_iterator >
Protected Member Functions inherited from clang::OMPClause
| OMPClause (OpenMPClauseKind K, SourceLocation StartLoc, SourceLocation EndLoc)
Protected Member Functions inherited from clang::OMPClauseWithPreInit
| OMPClauseWithPreInit (const OMPClause *This)
void | setPreInitStmt (Stmt *S, OpenMPDirectiveKind ThisRegion=llvm::omp::OMPD_unknown)
| Set pre-initialization statement for the clause. More...

## Detailed Description

This represents 'schedule' clause in the '#pragma omp ...' directive.

#pragma omp for schedule(static, 3)

In this example directive '#pragma omp for' has 'schedule' clause with arguments 'static' and '3'.

Definition at line 1281 of file OpenMPClause.h.

## Constructor & Destructor Documentation

## ◆ OMPScheduleClause() [1/2]

clang::OMPScheduleClause::OMPScheduleClause | ( | SourceLocation | StartLoc,
|  | SourceLocation | LParenLoc,
|  | SourceLocation | KLoc,
|  | SourceLocation | CommaLoc,
|  | SourceLocation | EndLoc,
|  | OpenMPScheduleClauseKind | Kind,
|  | Expr * | ChunkSize,
|  | Stmt * | HelperChunkSize,
|  | OpenMPScheduleClauseModifier | M1,
|  | SourceLocation | M1Loc,
|  | OpenMPScheduleClauseModifier | M2,
|  | SourceLocation | M2Loc
| ) |  |
| inline

Build 'schedule' clause with schedule kind Kind and chunk size expression ChunkSize.

Parameters

  StartLoc | Starting location of the clause.
  LParenLoc | Location of '('.
  KLoc | Starting location of the argument.
  CommaLoc | Location of ','.
  EndLoc | Ending location of the clause.
  Kind | Schedule kind.
  ChunkSize | Chunk size.
  HelperChunkSize | Helper chunk size for combined directives.
  M1 | The first modifier applied to 'schedule' clause.
  M1Loc | Location of the first modifier
  M2 | The second modifier applied to 'schedule' clause.
  M2Loc | Location of the second modifier

Definition at line 1383 of file OpenMPClause.h.

## ◆ OMPScheduleClause() [2/2]

clang::OMPScheduleClause::OMPScheduleClause | ( |  | ) |
| inline explicit

Build an empty clause.

Definition at line 1400 of file OpenMPClause.h.

References clang::OMPC_SCHEDULE_MODIFIER_unknown.

## Member Function Documentation

## ◆ children() [1/2]

child_range clang::OMPScheduleClause::children | ( |  | ) |
| inline

Definition at line 1445 of file OpenMPClause.h.

## ◆ children() [2/2]

const_child_range clang::OMPScheduleClause::children | ( |  | ) | const
| inline

Definition at line 1450 of file OpenMPClause.h.

References clang::OMPClause::children().

## ◆ classof()

static bool clang::OMPScheduleClause::classof | ( | const OMPClause * | T | ) |
| inline static

Definition at line 1462 of file OpenMPClause.h.

References clang::OMPClause::getClauseKind().

## ◆ getChunkSize() [1/2]

Expr* clang::OMPScheduleClause::getChunkSize | ( |  | ) |
| inline

Get chunk size.

Definition at line 1440 of file OpenMPClause.h.

Referenced by OMPNontemporalClause::setPrivateRefs(), clang::TreeTransform< Derived >::TransformOMPExecutableDirective(), and clang::ASTRecordWriter::writeOMPClause().

## ◆ getChunkSize() [2/2]

const Expr* clang::OMPScheduleClause::getChunkSize | ( |  | ) | const
| inline

Get chunk size.

Definition at line 1443 of file OpenMPClause.h.

## ◆ getCommaLoc()

SourceLocation clang::OMPScheduleClause::getCommaLoc | ( |  | ) |
| inline

Get location of ','.

Definition at line 1437 of file OpenMPClause.h.

Referenced by clang::TreeTransform< Derived >::TransformOMPExecutableDirective(), and clang::ASTRecordWriter::writeOMPClause().

## ◆ getFirstScheduleModifier()

OpenMPScheduleClauseModifier clang::OMPScheduleClause::getFirstScheduleModifier | ( |  | ) | const
| inline

Get the first modifier of the clause.

Definition at line 1411 of file OpenMPClause.h.

Referenced by clang::Sema::ActOnOpenMPRegionEnd(), OMPNontemporalClause::setPrivateRefs(), clang::TreeTransform< Derived >::TransformOMPExecutableDirective(), and clang::ASTRecordWriter::writeOMPClause().

## ◆ getFirstScheduleModifierLoc()

SourceLocation clang::OMPScheduleClause::getFirstScheduleModifierLoc | ( |  | ) | const
| inline

Get the first modifier location.

Definition at line 1427 of file OpenMPClause.h.

Referenced by clang::Sema::ActOnOpenMPRegionEnd(), clang::TreeTransform< Derived >::TransformOMPExecutableDirective(), and clang::ASTRecordWriter::writeOMPClause().

## ◆ getLParenLoc()

SourceLocation clang::OMPScheduleClause::getLParenLoc | ( |  | ) |
| inline

Get location of '('.

Definition at line 1421 of file OpenMPClause.h.

Referenced by clang::TreeTransform< Derived >::TransformOMPExecutableDirective(), and clang::ASTRecordWriter::writeOMPClause().

## ◆ getScheduleKind()

OpenMPScheduleClauseKind clang::OMPScheduleClause::getScheduleKind | ( |  | ) | const
| inline

Get kind of the clause.

Definition at line 1408 of file OpenMPClause.h.

Referenced by OMPNontemporalClause::setPrivateRefs(), clang::TreeTransform< Derived >::TransformOMPExecutableDirective(), and clang::ASTRecordWriter::writeOMPClause().

## ◆ getScheduleKindLoc()

SourceLocation clang::OMPScheduleClause::getScheduleKindLoc | ( |  | ) |
| inline

Get kind location.

Definition at line 1424 of file OpenMPClause.h.

Referenced by clang::TreeTransform< Derived >::TransformOMPExecutableDirective(), and clang::ASTRecordWriter::writeOMPClause().

## ◆ getSecondScheduleModifier()

OpenMPScheduleClauseModifier clang::OMPScheduleClause::getSecondScheduleModifier | ( |  | ) | const
| inline

Get the second modifier of the clause.

Definition at line 1416 of file OpenMPClause.h.

Referenced by clang::Sema::ActOnOpenMPRegionEnd(), OMPNontemporalClause::setPrivateRefs(), clang::TreeTransform< Derived >::TransformOMPExecutableDirective(), and clang::ASTRecordWriter::writeOMPClause().

## ◆ getSecondScheduleModifierLoc()

SourceLocation clang::OMPScheduleClause::getSecondScheduleModifierLoc | ( |  | ) | const
| inline

Get the second modifier location.

Definition at line 1432 of file OpenMPClause.h.

Referenced by clang::Sema::ActOnOpenMPRegionEnd(), clang::TreeTransform< Derived >::TransformOMPExecutableDirective(), and clang::ASTRecordWriter::writeOMPClause().

## ◆ used_children() [1/2]

child_range clang::OMPScheduleClause::used_children | ( |  | ) |
| inline

Definition at line 1455 of file OpenMPClause.h.

## ◆ used_children() [2/2]

const_child_range clang::OMPScheduleClause::used_children | ( |  | ) | const
| inline

Definition at line 1458 of file OpenMPClause.h.

## Friends And Related Function Documentation

## ◆ OMPClauseReader

friend class OMPClauseReader
| friend

Definition at line 1282 of file OpenMPClause.h.

The documentation for this class was generated from the following file:

- include/clang/AST/OpenMPClause.h